using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.IO;

namespace SnakeGame
{
    public class MySettings
    {

        private string xmlFile = "settings.xml";
        private XmlDocument xdoc;
        private XmlNode currentSection;

        private const string basicConfig =
            "<SnakeSettings>" +
                "<HighScore>0</HighScore>" +
                "<HighScoreName>Anonymous</HighScoreName>" +
            "</SnakeSettings>";

        public MySettings(string customConfigFile) {
            xdoc = new XmlDocument();
            xmlFile = customConfigFile;
            if (!File.Exists(xmlFile)) {
                File.WriteAllText(xmlFile, basicConfig);
            }

            xdoc.Load(xmlFile);

            //Initialise the currentSection to the root node
            currentSection = xdoc.ChildNodes[0];
        }

        public int getIntSetting(string name) {
            return int.Parse(getSetting(name));
        }

        public string getSetting(string name) {
            XmlNode rootnode = currentSection;

            for (int i = 0; i < rootnode.ChildNodes.Count; i++) {
                if (rootnode.ChildNodes[i].Name == name) {
                    return rootnode.ChildNodes[i].InnerText;
                }
            }

            throw new Exception("The Setting \""+name+"\" does not exist");
        }

        public void setSetting(string name, string value) {
            XmlNode rootnode = currentSection;

            for (int i = 0; i < rootnode.ChildNodes.Count; i++) {
                if (rootnode.ChildNodes[i].Name == name) {
                    rootnode.ChildNodes[i].InnerText = value;
                    xdoc.Save(xmlFile);
                    return;
                }
            }

            throw new Exception("The Setting \"" + name + "\" does not exist");
        }

        public void resetSettings() {
            xdoc = new XmlDocument();
            xdoc.LoadXml(basicConfig);

            //Huge mistake - it should retain the previous section selection
            //Not important here
            currentSection = xdoc.ChildNodes[0];//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

            xdoc.Save(xmlFile);
        }

    }
}
